#!/usr/local/bin/perl
#$Id: createtable.pl,v 1.3 1998/11/28 05:45:55 boris Exp $
#
#
#
# 室 䠩  ࠬ
#

    use Getopt::Std;

$usage = 'createtable.pl $Revision: 1.3 $, $Date: 1998/11/28 05:45:55 $'. "\n".
"Usage: createtable.pl [-d] [-t answers_file] [-m mail_file]  [-o results] \n";

require 'param.pl';
require 'subrout.pl';

die $usage unless getopts('t:m:o:d');

$DEBUG=$opt_d;

my %teams;
my @answers;
my @ratings;
#
# ⠥  १
#
if ($opt_t)
{
    die "Cannot open $opt_t\n" unless open(INFILE,$opt_t);
    readhash(\@answers);
    close(INFILE);
}

#
# ⠥ ⢥ 
#
if ($opt_m)
{
    die "Cannot open $opt_m\n" unless open(INFILE,$opt_m)
}
else
{
    *INFILE=*STDIN;
}
readmail(\%teams);
close(INFILE);
#
# ⨬  %answers
#
collect_answers(\%teams,\@answers);
#
# 뢠 ३⨭ ᮢ
#
rate_questions(\%teams,\@answers,\@ratings);
#
# 塞 ᫮ ⢥⮢  ३⨭ 
#
find_scores(\%teams,\@answers,\@ratings);
#
#   ⥯ ⠥ ᠬ ⠡...
#
if ($opt_o)
{
    die "Cannot open $opt_o\n" unless open(OUTFILE,">$opt_o");
    select OUTFILE;
}
#
# ⠥ 
#
printf "%5s", "N";
for ($i=1;$i<=$MAXQUEST;$i++)
{
    printf "%3d",$i;
}
printf "%3s","";
printf "%4s","";
printf " ";
print "\n";
#
# ⠥  筮
#
foreach $team (sort
                {
                    $teams{$b}->{score} <=> $teams{$a}->{score}
                    or
                        $teams{$b}->{rating} <=> $teams{$a}->{rating}
                } keys %teams
               )
{
    printf "%5d",$teams{$team}->{regnum};
    for ($i=1;$i<=$MAXQUEST;$i++)
    {
        my $answer = $teams{$team}->{answers}[$i];
        my $score = $answers[$i]->{$answer}->{score};
        $score = '-' unless $score;
            printf "%3s", $score;
    }
    printf "%3s",$teams{$team}->{score};
    printf "%4s",$teams{$team}->{rating};
    print " $team";
    print "\n";
}
#
# ⠥ ᫥ ப ⠡
#   ३⨭ ᮢ
#
printf "%5s", "";
for ($i=1; $i<=$MAXQUEST;$i++)
{
        printf "%3s", $ratings[$i];
}
print "\n";

